/*!
 * @overview RSVP - a tiny implementation of Promises/A+.
 * @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and contributors
 * @license   Licensed under MIT license
 *            See https://raw.githubusercontent.com/tildeio/rsvp.js/master/LICENSE
 * @version   3.0.14
 */
(function(){"use strict";function t(t,r){for(var e=0,n=t.length;e<n;e++){if(t[e]===r){return e}}return-1}function r(t){var r=t._promiseCallbacks;if(!r){r=t._promiseCallbacks={}}return r}var e={mixin:function(t){t["on"]=this["on"];t["off"]=this["off"];t["trigger"]=this["trigger"];t._promiseCallbacks=undefined;return t},on:function(e,n){var i=r(this),o;o=i[e];if(!o){o=i[e]=[]}if(t(o,n)===-1){o.push(n)}},off:function(e,n){var i=r(this),o,u;if(!n){i[e]=[];return}o=i[e];u=t(o,n);if(u!==-1){o.splice(u,1)}},trigger:function(t,e){var n=r(this),i,o;if(i=n[t]){for(var u=0;u<i.length;u++){o=i[u];o(e)}}}};var n={instrument:false};e.mixin(n);function i(t,r){if(t==="onerror"){n.on("error",r);return}if(arguments.length===2){n[t]=r}else{return n[t]}}function o(t){return typeof t==="function"||typeof t==="object"&&t!==null}function u(t){return typeof t==="function"}function a(t){return typeof t==="object"&&t!==null}var s;if(!Array.isArray){s=function(t){return Object.prototype.toString.call(t)==="[object Array]"}}else{s=Array.isArray}var f=s;var c=Date.now||function(){return(new Date).getTime()};function l(){}var h=Object.create||function(t){if(arguments.length>1){throw new Error("Second argument not supported")}if(typeof t!=="object"){throw new TypeError("Argument must be an object")}l.prototype=t;return new l};var v=[];function p(){setTimeout(function(){var t;for(var r=0;r<v.length;r++){t=v[r];var e=t.payload;e.guid=e.key+e.id;e.childGuid=e.key+e.childId;if(e.error){e.stack=e.error.stack}n["trigger"](t.name,t.payload)}v.length=0},50)}var _=function zr(t,r,e){if(1===v.push({name:t,payload:{key:r._guidKey,id:r._id,eventName:t,detail:r._result,childId:e&&e._id,label:r._label,timeStamp:c(),error:n["instrument-with-stack"]?new Error(r._label):null}})){p()}};function d(){return new TypeError("A promises callback cannot return that same promise.")}function y(){}var m=void 0;var w=1;var g=2;var b=new M;function A(t){try{return t.then}catch(r){b.error=r;return b}}function E(t,r,e,n){try{t.call(r,e,n)}catch(i){return i}}function j(t,r,e){n.async(function(t){var n=false;var i=E(e,r,function(e){if(n){return}n=true;if(r!==e){S(t,e)}else{O(t,e)}},function(r){if(n){return}n=true;R(t,r)},"Settle: "+(t._label||" unknown promise"));if(!n&&i){n=true;R(t,i)}},t)}function T(t,r){if(r._state===w){O(t,r._result)}else if(t._state===g){R(t,r._result)}else{I(r,undefined,function(e){if(r!==e){S(t,e)}else{O(t,e)}},function(r){R(t,r)})}}function k(t,r){if(r.constructor===t.constructor){T(t,r)}else{var e=A(r);if(e===b){R(t,b.error)}else if(e===undefined){O(t,r)}else if(u(e)){j(t,r,e)}else{O(t,r)}}}function S(t,r){if(t===r){O(t,r)}else if(o(r)){k(t,r)}else{O(t,r)}}function C(t){if(t._onerror){t._onerror(t._result)}x(t)}function O(t,r){if(t._state!==m){return}t._result=r;t._state=w;if(t._subscribers.length===0){if(n.instrument){_("fulfilled",t)}}else{n.async(x,t)}}function R(t,r){if(t._state!==m){return}t._state=g;t._result=r;n.async(C,t)}function I(t,r,e,i){var o=t._subscribers;var u=o.length;t._onerror=null;o[u]=r;o[u+w]=e;o[u+g]=i;if(u===0&&t._state){n.async(x,t)}}function x(t){var r=t._subscribers;var e=t._state;if(n.instrument){_(e===w?"fulfilled":"rejected",t)}if(r.length===0){return}var i,o,u=t._result;for(var a=0;a<r.length;a+=3){i=r[a];o=r[a+e];if(i){Y(e,i,o,u)}else{o(u)}}t._subscribers.length=0}function M(){this.error=null}var N=new M;function P(t,r){try{return t(r)}catch(e){N.error=e;return N}}function Y(t,r,e,n){var i=u(e),o,a,s,f;if(i){o=P(e,n);if(o===N){f=true;a=o.error;o=null}else{s=true}if(r===o){R(r,d());return}}else{o=n;s=true}if(r._state!==m){}else if(i&&s){S(r,o)}else if(f){R(r,a)}else if(t===w){O(r,o)}else if(t===g){R(r,o)}}function D(t,r){try{r(function n(r){S(t,r)},function i(r){R(t,r)})}catch(e){R(t,e)}}function K(t,r,e){if(t===w){return{state:"fulfilled",value:e}}else{return{state:"rejected",reason:e}}}function U(t,r,e,n){this._instanceConstructor=t;this.promise=new t(y,n);this._abortOnReject=e;if(this._validateInput(r)){this._input=r;this.length=r.length;this._remaining=r.length;this._init();if(this.length===0){O(this.promise,this._result)}else{this.length=this.length||0;this._enumerate();if(this._remaining===0){O(this.promise,this._result)}}}else{R(this.promise,this._validationError())}}U.prototype._validateInput=function(t){return f(t)};U.prototype._validationError=function(){return new Error("Array Methods must be provided an Array")};U.prototype._init=function(){this._result=new Array(this.length)};var q=U;U.prototype._enumerate=function(){var t=this.length;var r=this.promise;var e=this._input;for(var n=0;r._state===m&&n<t;n++){this._eachEntry(e[n],n)}};U.prototype._eachEntry=function(t,r){var e=this._instanceConstructor;if(a(t)){if(t.constructor===e&&t._state!==m){t._onerror=null;this._settledAt(t._state,r,t._result)}else{this._willSettleAt(e.resolve(t),r)}}else{this._remaining--;this._result[r]=this._makeResult(w,r,t)}};U.prototype._settledAt=function(t,r,e){var n=this.promise;if(n._state===m){this._remaining--;if(this._abortOnReject&&t===g){R(n,e)}else{this._result[r]=this._makeResult(t,r,e)}}if(this._remaining===0){O(n,this._result)}};U.prototype._makeResult=function(t,r,e){return e};U.prototype._willSettleAt=function(t,r){var e=this;I(t,undefined,function(t){e._settledAt(w,r,t)},function(t){e._settledAt(g,r,t)})};var F=function Br(t,r){return new q(this,t,true,r).promise};var G=function Hr(t,r){var e=this;var n=new e(y,r);if(!f(t)){R(n,new TypeError("You must pass an array to race."));return n}var i=t.length;function o(t){S(n,t)}function u(t){R(n,t)}for(var a=0;n._state===m&&a<i;a++){I(e.resolve(t[a]),undefined,o,u)}return n};var L=function Jr(t,r){var e=this;if(t&&typeof t==="object"&&t.constructor===e){return t}var n=new e(y,r);S(n,t);return n};var V=function Qr(t,r){var e=this;var n=new e(y,r);R(n,t);return n};var W="rsvp_"+c()+"-";var z=0;function B(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}function H(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}var J=Q;function Q(t,r){this._id=z++;this._label=r;this._state=undefined;this._result=undefined;this._subscribers=[];if(n.instrument){_("created",this)}if(y!==t){if(!u(t)){B()}if(!(this instanceof Q)){H()}D(this,t)}}Q.cast=L;Q.all=F;Q.race=G;Q.resolve=L;Q.reject=V;Q.prototype={constructor:Q,_guidKey:W,_onerror:function(t){n["trigger"]("error",t)},then:function(t,r,e){var i=this;var o=i._state;if(o===w&&!t||o===g&&!r){if(n.instrument){_("chained",this,this)}return this}i._onerror=null;var u=new this.constructor(y,e);var a=i._result;if(n.instrument){_("chained",i,u)}if(o){var s=arguments[o-1];n.async(function(){Y(o,u,s,a)})}else{I(i,u,t,r)}return u},"catch":function(t,r){return this.then(null,t,r)},"finally":function(t,r){var e=this.constructor;return this.then(function(r){return e.resolve(t()).then(function(){return r})},function(r){return e.resolve(t()).then(function(){throw r})},r)}};function X(){this.value=undefined}var Z=new X;var $=new X;function tr(t){try{return t.then}catch(r){Z.value=r;return Z}}function rr(t,r,e){try{t.apply(r,e)}catch(n){Z.value=n;return Z}}function er(t,r){var e={};var n;var i;var o=t.length;var u=new Array(o);for(var a=0;a<o;a++){u[a]=t[a]}for(i=0;i<r.length;i++){n=r[i];e[n]=u[i+1]}return e}function nr(t){var r=t.length;var e=new Array(r-1);for(var n=1;n<r;n++){e[n-1]=t[n]}return e}function ir(t,r){return{then:function(e,n){return t.call(r,e,n)}}}var or=function Xr(t,r){var e=function(){var e=this;var n=arguments.length;var i=new Array(n+1);var o;var u=false;for(var a=0;a<n;++a){o=arguments[a];if(!u){u=sr(o);if(u===$){var s=new J(y);R(s,$.value);return s}else if(u&&u!==true){o=ir(u,o)}}i[a]=o}var c=new J(y);i[n]=function(t,e){if(t)R(c,t);else if(r===undefined)S(c,e);else if(r===true)S(c,nr(arguments));else if(f(r))S(c,er(arguments,r));else S(c,e)};if(u){return ar(c,i,t,e)}else{return ur(c,i,t,e)}};e.__proto__=t;return e};function ur(t,r,e,n){var i=rr(e,n,r);if(i===Z){R(t,i.value)}return t}function ar(t,r,e,n){return J.all(r).then(function(r){var i=rr(e,n,r);if(i===Z){R(t,i.value)}return t})}function sr(t){if(t&&typeof t==="object"){if(t.constructor===J){return true}else{return tr(t)}}else{return false}}var fr=function Zr(t,r){return J.all(t,r)};function cr(t,r,e){this._superConstructor(t,r,false,e)}cr.prototype=h(q.prototype);cr.prototype._superConstructor=q;cr.prototype._makeResult=K;cr.prototype._validationError=function(){return new Error("allSettled must be called with an array")};var lr=function $r(t,r){return new cr(J,t,r).promise};var hr=function te(t,r){return J.race(t,r)};function vr(t,r,e){this._superConstructor(t,r,true,e)}var pr=vr;vr.prototype=h(q.prototype);vr.prototype._superConstructor=q;vr.prototype._init=function(){this._result={}};vr.prototype._validateInput=function(t){return t&&typeof t==="object"};vr.prototype._validationError=function(){return new Error("Promise.hash must be called with an object")};vr.prototype._enumerate=function(){var t=this.promise;var r=this._input;var e=[];for(var n in r){if(t._state===m&&r.hasOwnProperty(n)){e.push({position:n,entry:r[n]})}}var i=e.length;this._remaining=i;var o;for(var u=0;t._state===m&&u<i;u++){o=e[u];this._eachEntry(o.entry,o.position)}};var _r=function re(t,r){return new pr(J,t,r).promise};function dr(t,r,e){this._superConstructor(t,r,false,e)}dr.prototype=h(pr.prototype);dr.prototype._superConstructor=q;dr.prototype._makeResult=K;dr.prototype._validationError=function(){return new Error("hashSettled must be called with an object")};var yr=function ee(t,r){return new dr(J,t,r).promise};var mr=function ne(t){setTimeout(function(){throw t});throw t};var wr=function ie(t){var r={};r["promise"]=new J(function(t,e){r["resolve"]=t;r["reject"]=e},t);return r};var gr=function oe(t,r,e){return J.all(t,e).then(function(t){if(!u(r)){throw new TypeError("You must pass a function as map's second argument.")}var n=t.length;var i=new Array(n);for(var o=0;o<n;o++){i[o]=r(t[o])}return J.all(i,e)})};var br=function ue(t,r){return J.resolve(t,r)};var Ar=function ae(t,r){return J.reject(t,r)};var Er=function se(t,r,e){return J.all(t,e).then(function(t){if(!u(r)){throw new TypeError("You must pass a function as filter's second argument.")}var n=t.length;var i=new Array(n);for(var o=0;o<n;o++){i[o]=r(t[o])}return J.all(i,e).then(function(r){var e=new Array(n);var i=0;for(var o=0;o<n;o++){if(r[o]){e[i]=t[o];i++}}e.length=i;return e})})};var jr=0;var Tr=function fe(t,r){Pr[jr]=t;Pr[jr+1]=r;jr+=2;if(jr===2){Kr()}};var kr=typeof window!=="undefined"?window:undefined;var Sr=kr||{};var Cr=Sr.MutationObserver||Sr.WebKitMutationObserver;var Or=typeof Uint8ClampedArray!=="undefined"&&typeof importScripts!=="undefined"&&typeof MessageChannel!=="undefined";function Rr(){return function(){process.nextTick(Yr)}}function Ir(){return function(){vertxNext(Yr)}}function xr(){var t=0;var r=new Cr(Yr);var e=document.createTextNode("");r.observe(e,{characterData:true});return function(){e.data=t=++t%2}}function Mr(){var t=new MessageChannel;t.port1.onmessage=Yr;return function(){t.port2.postMessage(0)}}function Nr(){return function(){setTimeout(Yr,1)}}var Pr=new Array(1e3);function Yr(){for(var t=0;t<jr;t+=2){var r=Pr[t];var e=Pr[t+1];r(e);Pr[t]=undefined;Pr[t+1]=undefined}jr=0}function Dr(){try{var t=require("vertx");var r=t.runOnLoop||t.runOnContext;return Ir()}catch(e){return Nr()}}var Kr;if(typeof process!=="undefined"&&{}.toString.call(process)==="[object process]"){Kr=Rr()}else if(Cr){Kr=xr()}else if(Or){Kr=Mr()}else if(kr===undefined&&typeof require==="function"){Kr=Dr()}else{Kr=Nr()}n.async=Tr;var Ur=br;function qr(t,r){n.async(t,r)}function Fr(){n.on.apply(n,arguments)}function Gr(){n.off.apply(n,arguments)}if(typeof window!=="undefined"&&typeof window["__PROMISE_INSTRUMENTATION__"]==="object"){var Lr=window["__PROMISE_INSTRUMENTATION__"];i("instrument",true);for(var Vr in Lr){if(Lr.hasOwnProperty(Vr)){Fr(Vr,Lr[Vr])}}}var Wr={race:hr,Promise:J,allSettled:lr,hash:_r,hashSettled:yr,denodeify:or,on:Fr,off:Gr,map:gr,filter:Er,resolve:br,reject:Ar,all:fr,rethrow:mr,defer:wr,EventTarget:e,configure:i,async:qr};if(typeof define==="function"&&define["amd"]){define(function(){return Wr})}else if(typeof module!=="undefined"&&module["exports"]){module["exports"]=Wr}else if(typeof this!=="undefined"){this["RSVP"]=Wr}}).call(this);